
#include <QWidget>
#include <QVariant>
#include <QTextEdit>
#include <QStatusBar>
#include <QLabel>

/*
QT_BEGIN_NAMESPACE
class QComboBox;
class QLineEdit;
QT_END_NAMESPACE
*/
//! [0]
#include <QProcess>
class Shell: public QObject
{
    Q_OBJECT
public: 
	Shell();
	void 	putch(char ch);
	//void 	write(char ch);

protected slots:
	void  	cmd_started();
	void 	cmd_finished ( int exitCode, QProcess::ExitStatus exitStatus );
	void 	cmd_error ( QProcess::ProcessError error );
	void  	cmd_ok();
	void  	readOut();
	void 	readStdout(int n);

protected :
	virtual void setupChildProcess();
	static int stdinClone;
};


#include <QTextCursor>
class Screen : public QTextEdit
{
Q_OBJECT

public:
    Screen();
	QTextCursor cursor;
    void newline();
    void reset();
    void eraseAll();
	void print_char(char c);
	void ctrl_char(char c);
	void delchar();
	void CR();
	void attr(int Ps);
	void drawCursor();

public slots:
//    void echoChanged(int);
 //  void validatorChanged(int);
  //  void alignmentChanged(int);
  //  void inputMaskChanged(int);
   // void accessChanged(int);
	virtual void keyPressEvent ( QKeyEvent *e);
 // 	virtual void inputMethodEvent(QInputMethodEvent *e);
//	virtual QVariant inputMethodQuery(Qt::InputMethodQuery property) const;
private:
	int flag;
};


class StatusBar : public QStatusBar
{
	Q_OBJECT
	public:
		StatusBar(QWidget *parent);
    	void refresh();
    	void update(int n);
		QLabel *label;
};

class VTerm : public QWidget
{
    Q_OBJECT

public:
    VTerm();
	bool settings_load();
	bool settings_save();

public slots:
	void closeEvent(QCloseEvent *e);
	void run_fontsel(bool b);
//    void echoChanged(int);
 //  void validatorChanged(int);
  //  void alignmentChanged(int);
  //  void inputMaskChanged(int);
   // void accessChanged(int);
   // void inputMethodEvent(QInputMethodEvent *e);
//	virtual QVariant inputMethodQuery(Qt::InputMethodQuery property) const;

private:
  /*  QLineEdit *echoLineEdit;
    QLineEdit *validatorLineEdit;
    QLineEdit *alignmentLineEdit;
    QLineEdit *inputMaskLineEdit;
    QLineEdit *accessLineEdit;
*/
  };
//! [0]

class TermCursor : public QObject
{
	Q_OBJECT
	public:
		TermCursor(){ x=0,y=0;};
		TermCursor(QWidget *parent){};
//		virtual void paintEvent(  QPaintEvent * event ){}; 
		int x;
		int y;
};

class Screen2 : public QWidget
{
	Q_OBJECT
	public:
		Screen2(QWidget *parent);
		void setFont(QFont font);
		//void setText(QString str);
		//void draw( QPainter &p );
		//void showText(QPoint pos,QString str);
		//void setPos(int x,int y);
	void updateCell(int r,int c);
		void append(QString &str);
   	void newline();
    void reset();
    void redraw();
    void eraseAll();
    void clear();
	void print_char(char c);
	void ctrl_char(char c);
	void delchar();
	void CR();
	void attr(int Ps);
	int yposRow(int r);
	void drawCursor(QPainter &p) ;
//	void drawCursor();
	protected slots:
//    		void refresh();
  		void timer_update();
//		QToolButton *button,*button2,*button3;
//		void event_cursor_moved(QMouseEvent *e);
 	//	void setValue(int	val);

	protected :
		virtual void paintEvent(  QPaintEvent * event ); 
//		virtual void moveEvent (QMoveEvent * event ); 
//		virtual void showEvent ( QShowEvent * event );
		virtual void keyPressEvent ( QKeyEvent *e);
		virtual void resizeEvent ( QResizeEvent * e );
	private:
		QString text;
		//QTimeLine *timeLine;
		float 	opacity;

};
