#include "vkb.h"
#include "qinputcontexthangul.h"


//extern Widget *main_widget;
#define keypad VirtualKeyboard

keypad::keypad(QInputContextHangul *xic) :
    QWidget(NULL)
{
	int flag_slashmode=0;
	//setObjectName("vkb");
    m_ui=new Ui_vkb;
   	m_ui->setupUi(this);
	//setFocusWidget
	//setFocusPolicy ( Qt::NoFocus );
	//	printf("hangul:lostFocusWidget !\n");	
///	m_ui->lineEdit->setAttribute(Qt::WA_InputMethodEnabled,false);
	//targetWidget=w;
	ic=xic;

	if(flag_slashmode)
	{
		Qt::WindowFlags flags = 0;
		flags=windowFlags();
		flags|=Qt::X11BypassWindowManagerHint;
		//flags=Qt::Popup;
		setWindowFlags(flags);
	}
	//w->window()->setWindowFlags(0);
}

keypad::~keypad()
{
	printf("vkb destruct!\n");
    delete m_ui;
	printf("vkb destruct! end\n");
}

QString keypad::getText(){

	return m_ui->vkbedit->text();
}
// Function Key

void keypad::on_finish_clicked()
{
	ic->putAsciiKey(VK_FINISH);
	m_ui->vkbedit->setText("");
	hide();
}

void keypad::on_setHan_clicked()
{
    m_ui->stackedWidget->setCurrentIndex(1);
	ic->putAsciiKey(VK_HANGULE);
}

void keypad::on_setEng_clicked()
{
    m_ui->stackedWidget->setCurrentIndex(0);
	ic->putAsciiKey(VK_ENG);
}
void keypad::on_setNum_clicked()
{
    m_ui->stackedWidget->setCurrentIndex(2);
}
void keypad::on_BS_clicked()
{     ic->putAsciiKey(0x08);    }

void keypad::on_RESET_clicked()
{
	m_ui->vkbedit->setText("");
}

// Alphabet Key
void keypad::on_A_clicked()
{     ic->putAsciiKey('A');    }
void keypad::on_B_clicked()
{	ic->putAsciiKey('B');    }
void keypad::on_C_clicked()
{	ic->putAsciiKey('C');    }
void keypad::on_D_clicked()
{	ic->putAsciiKey('D');    }
void keypad::on_E_clicked()
{	ic->putAsciiKey('E');    }
void keypad::on_F_clicked()
{	ic->putAsciiKey('F');    }
void keypad::on_G_clicked()
{	ic->putAsciiKey('G');    }
void keypad::on_H_clicked()
{	ic->putAsciiKey('H');    }
void keypad::on_I_clicked()
{	ic->putAsciiKey('I');    }
void keypad::on_J_clicked()
{	ic->putAsciiKey('J');    }
void keypad::on_K_clicked()
{	ic->putAsciiKey('K');    }
void keypad::on_L_clicked()
{	ic->putAsciiKey('L');    }
void keypad::on_M_clicked()
{	ic->putAsciiKey('M');    }
void keypad::on_N_clicked()
{	ic->putAsciiKey('N');    }
void keypad::on_O_clicked()
{	ic->putAsciiKey('O');    }
void keypad::on_P_clicked()
{	ic->putAsciiKey('P');    }
void keypad::on_Q_clicked()
{	ic->putAsciiKey('Q');    }
void keypad::on_R_clicked()
{	ic->putAsciiKey('R');    }
void keypad::on_S_clicked()
{	ic->putAsciiKey('S');    }
void keypad::on_T_clicked()
{	ic->putAsciiKey('T');    }
void keypad::on_U_clicked()
{	ic->putAsciiKey('U');    }
void keypad::on_VW_clicked()
{	ic->putAsciiKey('V');    } /// **** 
void keypad::on_X_clicked()
{	ic->putAsciiKey('X');    }
void keypad::on_Y_clicked()
{	ic->putAsciiKey('Y');    }
void keypad::on_Z_clicked()
{	ic->putAsciiKey('Z');    }


//Hangul Key
void keypad::on_H_Q_clicked() // ㅂ
{	ic->putAsciiKey('q');  }
void keypad::on_H_W_clicked() // 
{	ic->putAsciiKey('w');}
void keypad::on_H_E_clicked() // 
{	ic->putAsciiKey('e');}
void keypad::on_H_R_clicked() // 
{	ic->putAsciiKey('r');}

 void keypad::on_H_T_clicked() // ㅅ
 { ic->putAsciiKey('t'); }
 void keypad::on_H_A_clicked() // ㅁ
         { ic->putAsciiKey('a'); }
void keypad::on_H_S_clicked() // ㄴ
        { ic->putAsciiKey('s'); }
void keypad::on_H_D_clicked() // ㅇ
        {ic->putAsciiKey('d');  }
void keypad::on_H_F_clicked() // ㄹ
        {ic->putAsciiKey('f');  }
void keypad::on_H_G_clicked() // ㅎ
        {ic->putAsciiKey('g');  }
void keypad::on_H_Z_clicked() // ㅋ
        {ic->putAsciiKey('z');  }
void keypad::on_H_X_clicked() // ㅌ
        {ic->putAsciiKey('x');  }
void keypad::on_H_C_clicked() // ㅊ
        {ic->putAsciiKey('c');  }
void keypad::on_H_V_clicked() // ㅍ
{ ic->putAsciiKey('v'); }

void keypad::on_H_K_clicked() // ㅏㅑ
        { ic->putAsciiKey('k'); }
void keypad::on_H_J_clicked() // ㅓㅕ
        {ic->putAsciiKey('j');  }
void keypad::on_H_H_clicked() // ㅗㅛ
        {ic->putAsciiKey('h');  }
void keypad::on_H_N_clicked() // ㅜㅠ
        {ic->putAsciiKey('n');  }
void keypad::on_H_M_clicked() // ㅡ
        {ic->putAsciiKey('m');  }
void keypad::on_H_L_clicked() // ㅣ
        {ic->putAsciiKey('l');  }
void keypad::on_H_O_clicked() // ㅐㅒ
        {ic->putAsciiKey('o');  }
void keypad::on_H_P_clicked() // ㅔㅖ
        {ic->putAsciiKey('p');  }

// Number Key
void keypad::on_N_1_clicked() // 
{	ic->putAsciiKey('1');  }
void keypad::on_N_2_clicked() //
{	ic->putAsciiKey('2');  }
void keypad::on_N_3_clicked() //
{	ic->putAsciiKey('3');  }
void keypad::on_N_4_clicked() //
{	ic->putAsciiKey('4');  }
void keypad::on_N_5_clicked() //
{	ic->putAsciiKey('5');  }
void keypad::on_N_6_clicked() //
{	ic->putAsciiKey('6');  }
void keypad::on_N_7_clicked() //
{	ic->putAsciiKey('7');  }
void keypad::on_N_8_clicked() //
{	ic->putAsciiKey('8');  }
void keypad::on_N_9_clicked() //
{	ic->putAsciiKey('9');  }
void keypad::on_N_0_clicked() //
{	ic->putAsciiKey('0');  }

